import java.lang.reflect.Array;
import java.util.*;

public class Arraz {

    public int sumValuesOfArrays(int[] intArray) {
        int result = 0;
        for (int i: intArray) {
            result+=i;
        }
        return result;
    }

    public Double sumDoubleOfArrays(Double[] doubleArray) {
        double result = 0;
        for (Double d: doubleArray) {
            result+=d;
        }
        return result;
    }

    public int average(int[] arr) {
        return sumValuesOfArrays(arr)/arr.length;
    }

    public Double averageDbl(Double[] arr) {
        return sumDoubleOfArrays(arr)/arr.length;
    }

    public boolean containsValue(int[] spiffyHandyIntArray, int i) {
        for (int value: spiffyHandyIntArray) {
            if(i==value){return true;}
        }
        return false;
    }

    public int[] reverse(int[] arr) {
        for(int i = 0; i<arr.length/2; i++){
           int temp = arr[i];
           arr[i]=arr[arr.length-1];
           arr[arr.length-1-i]=temp;
        }
        return arr;
    }

    public OddEven getOddEvensOfArray(int[] arr) {
        int even = 0;
        int odd = 0;
        for (int i: arr) {
            if(i%2==0) even++;
            else odd++;
        }
        return new OddEven(odd, even);
    }

    public int findIndexOf(int[] arr, int value) {
        for (int i=0; i<arr.length; i++) {
            if (arr[i] == value) {
                return i;
            }
            }
        return -1;
    }

    public Integer[] copyArrayByIterator(Integer[] arr) {
        Integer[] array = new Integer[arr.length];
        Iterator<Integer> iterator = Arrays.asList(arr).iterator();
        int counter = 0;
        while(iterator.hasNext()){
            array[counter]=iterator.next();
            counter++;
        }
        return  array;
        }


    public int[] copyArrayByLoop(int[] arr) {
        int [] result = new int[arr.length];
        for(int i=0; i<arr.length; i++){
            result[i]=arr[i];
        }
        return result;
    }

    public int[] removeElement(int[] arr, int val) {
        int[] result = new int[arr.length];
        for(int i=0; i<arr.length; i++){
            if(arr[i]!=val)
            result[i]=arr[i];
        }
        return result;
    }

    public int[] insertIntoArrayAt(int[] arr, int val, int index) {
        int[] result = new int[arr.length+1];
        int counter = 0;
        for (int i = 0; i <result.length; i++) {
            if (i != index){
                result[i] = arr[counter];
                counter++;
            } else result[i] = val;
        }
        return result;
    }

    public MinMax findMinMax(int[] arr) {
        Arrays.sort(arr);
        return new MinMax(arr[0], arr[arr.length-1]);
    }

    public Integer[] removeDupes(Integer[] arr) {
        ArrayList<Integer> result = new ArrayList<Integer>();
        Set<Integer> set = new HashSet<Integer>();
        for (Integer i : arr) {
            set.add(i);
        }
        for (Integer i: set) {
            result.add(i);
        }
        Integer[] foo = (Integer[]) result.toArray();
        return foo;
    }
}
